#
# VLDB submission 'Dependable Cardinality Forecasts for XQuery'
# (Jens Teubner, Torsten Grust, Sebastian Maneth, and Sherif Sakr)
#
# (c) 2008 Jens Teubner, IBM Research, teubner@us.ibm.com
#

#
# W3C XQuery Use Case Q1
#
# <bib>
#  {
#    for $b in doc("http://bstore1.example.com/bib.xml")/bib/book
#    where $b/publisher = "Addison-Wesley" and $b/@year > 1991
#    return
#      <book year="{ $b/@year }">
#        { $b/title }
#      </book>
#  }
# </bib> 

a39 = LiteralTable.new :id => "a39",
                       :colnames => [ :iter ],
                       :data   => [ [   1   ] ]

a38 = Project.new :id => "a38", :input => a39,
                  :projlist => [ [:iter], [:item, "bib.xml"] ]

a01 = Doc.new :id => "a01", :input => a38, :src => :item

a02 = Scj.new :id => "a02",
              :input => a01, :src => :item, :step => "child::bib"

a03 = Scj.new :id => "a03",
              :input => a02, :src => :item, :step => "child::book"

a04 = Rownum.new :id => "a04", :input => a03, :newcol => :pos,
                 :order => [ :item ], :part => :iter

a05 = Rownum.new :id => "a05", :input => a04, :newcol => :inner,
                 :order => [ :iter, :pos ]

a06 = Project.new :id => "a06", :input => a05,
                  :projlist => [ [ :iter, :inner ], [:item] ]

a07 = Scj.new :id => "a07",
              :input => a06, :src => :item, :step => "child::title"

a08 = Rownum.new :id => "a08", :input => a07, :newcol => :pos,
                 :order => [ :item ], :part => :iter

a09 = Project.new :id => "a09", :input => a08,
                  :projlist => [ [:iter1,:iter], [:pos], [:item] ]

a10 = Project.new :id => "a10", :input => a06,
                  :projlist => [ [:iter1,:iter], [:pos1,1],
                                 [:item1,"Addison-Wesley"] ]

a11 = Scj.new :id => "a11", :input => a06, :src => :item,
              :step => "child::publisher"

a12 = Rownum.new :id => "a12", :input => a11, :newcol => :pos,
                 :order => [ :item ], :part => :iter

a13 = Atomize.new :id => "a13", :input => a12, :src => :item, :dest => :item

a14 = Join.new :id => "a14", :left_rel => a10, :right_rel => a13,
               :left_col => :iter1, :right_col => :iter

a15 = EqualOp.new :id => "a15", :input => a14, :newcol => :res,
                  :arg1 => :item, :arg2 => :item1

a40 = Select.new :id => "a40", :input => a15, :column => :res

a16 = Project.new :id => "a16", :input => a40, :projlist => [ [:iter] ]

a17 = Project.new :id => "a17", :input => a06,
                  :projlist => [ [:iter1,:iter], [:pos1,1], [:item1,1991] ]

a18 = Scj.new :id => "a18", :input => a06, :src => :item,
              :step => "attribute::year"

a19 = Rownum.new :id => "a19", :input => a18, :newcol => :pos,
                 :order => [ :item ], :part => :iter

a20 = Atomize.new :id => "a20", :input => a19, :src => :item, :dest => :item

a21 = Join.new :id => "a21", :left_rel => a17, :right_rel => a20,
               :left_col => :iter1, :right_col => :iter

a22 = GreaterThanOp.new :id => "a22", :input => a21, :newcol => :res,
                        :arg1 => :item, :arg2 => :item1

a41 = Select.new :id => "a41", :input => a22, :column => :res

a23 = Project.new :id => "a23", :input => a41, :projlist => [ [:iter] ]

a24 = Intersect.new :id => "a24", :left_rel => a16, :right_rel => a23

a25 = Distinct.new :id => "a25", :input => a24

a26 = Join.new :id => "a26", :left_rel => a09, :right_rel => a25,
               :left_col => :iter1, :right_col => :iter

a27 = Project.new :id => "a27", :input => a26,
                  :projlist => [ [:iter], [:pos], [:item], [:ord,2] ]

a29 = Project.new :id => "a29", :input => a19,
                  :projlist => [ [:iter1,:iter], [:pos], [:item] ]

a28 = Join.new :id => "a28", :left_rel => a25, :right_rel => a29,
               :left_col => :iter, :right_col => :iter1

a30 = Project.new :id => "a30", :input => a28,
                  :projlist => [ [:iter], [:pos], [:item], [:ord,1] ]

a31 = Union.new :id => "a31", :left_rel => a27, :right_rel => a30

a32 = Project.new :id => "a32", :input => a31,
                  :projlist => [ [:iter], [:pos], [:item] ]

a33 = Project.new :id => "a33", :input => a25,
                  :projlist => [ [:iter], [:pos,1], [:item,"book"] ]

a34 = ElemConstr.new :id => "a34", :tagnames => a33, :content => a32

a42 = Project.new :id => "a42", :input => a05,
                  :projlist => [ [:outer,:iter], [:inner] ]

a35 = Join.new :id => "a35", :left_rel => a42, :right_rel => a34,
               :left_col => :inner, :right_col => :iter

a36 = Project.new :id => "a36", :input => a35,
                  :projlist => [ [:iter,:outer], [:pos], [:item] ]

a43 = Project.new :id => "a43", :input => a39,
                  :projlist => [ [:iter], [:pos,1], [:item,"bib"] ]

a37 = ElemConstr.new :id => "a37", :tagnames => a43, :content => a36

$root = a37
