#
# VLDB submission 'Dependable Cardinality Forecasts for XQuery'
# (Jens Teubner, Torsten Grust, Sebastian Maneth, and Sherif Sakr)
#
# (c) 2008 Jens Teubner, IBM Research, teubner@us.ibm.com
#

#
# Example query in the paper
#

a45 = LiteralTable.new :id => "a45",
                       :colnames => [ :iter ],
                       :data   => [ [   1   ] ]

a44 = Project.new :id => "a44",
                  :input => a45,
                  :projlist => [ [:iter], [:item, "forecast.xml"] ]

a01 = Doc.new :id => "a01", :input => a44, :src => :item

a02 = Scj.new :id => "a02",
              :input => a01, :src => :item, :step => "descendant::day"

a03 = Rownum.new :id => "a03", :input => a02, :newcol => :pos,
                 :order => [ :item ], :part => :iter

a04 = Rownum.new :id => "a04", :input => a03, :newcol => :inner,
                 :order => [ :iter, :pos ]

a05 = Project.new :id => "a05", :input => a04,
                  :projlist => [ [ :iter, :inner ], [:item] ]

a09 = Scj.new :id => "a09", :input => a05,
              :src => :item, :step => "attribute::t"

a11 = Rownum.new :id => "a11", :input => a09, :newcol => :pos,
                 :order => [:item], :part => :iter

a39 = Project.new :id => "a39", :input => a11,
                  :projlist => [ [ :iter1, :iter ], [:pos], [:item] ]

a07 = Scj.new :id => "a07", :input => a05,
              :src => :item, :step => "descendant::ppcp"

a10 = Rownum.new :id => "a10", :input => a07, :newcol => :pos,
                 :order => [ :item ], :part => :iter
a12 = Atomize.new :id => "a12", :input => a10, :src => :item, :dest => :item

a42 = Project.new :id => "a42", :input => a05, :projlist => [ [:iter] ]

a08 = Project.new :id => "a08", :input => a42,
                  :projlist => [ [:iter1, :iter], [:pos1, 1], [:item1, 50] ]

a13 = Join.new :id => "a13", :left_rel => a08, :right_rel => a12,
               :left_col => :iter1, :right_col => :iter

a14 = GreaterThanOp.new :id => "a14", :input => a13, :newcol => :res,
                        :arg1 => :item, :arg2 => :item1

a15 = Select.new :id => "a15", :input => a14, :column => :res

a16 = Project.new :id => "a16", :input => a15, :projlist => [ [:iter] ]

a17 = Distinct.new :id => "a17", :input => a16

a19 = Join.new :id => "a19", :left_rel => a39, :right_rel => a17,
               :left_col => :iter1, :right_col => :iter

a41 = Project.new :id => "a41", :input => a12,
                  :projlist => [ [:iter1,:iter], [:pos], [:item] ]

a40 = Join.new :id => "a40", :left_rel => a17, :right_rel => a41,
               :left_col => :iter, :right_col => :iter1

a24 = Project.new :id => "a24", :input => a17,
                  :projlist => [ [:iter], [:pos,1], [:ord,3],
                                 [:item, "chance of precipitation"] ]

a25 = Project.new :id => "a25", :input => a40,
                  :projlist => [ [:iter], [:pos], [:item], [:ord,4] ]

a29 = Union.new :id => "a29", :left_rel => a24, :right_rel => a25

a23 = Project.new :id => "a23", :input => a19,
                  :projlist => [ [:iter], [:pos], [:item], [:ord, 2] ]

a28 = Union.new :id => "a28", :left_rel => a23, :right_rel => a29

a22 = Project.new :id => "a22", :input => a17,
                  :projlist => [ [:iter], [:pos, 1], [:ord, 1],
                                 [:item, "rain likely on"] ]

a27 = Union.new :id => "a27", :left_rel => a22, :right_rel => a28

a18 = Difference.new :id => "a18", :left_rel => a42, :right_rel => a17

a20 = Join.new :id => "a20", :left_rel => a39, :right_rel => a18,
               :left_col => :iter1, :right_col => :iter

a26 = Project.new :id => "a26", :input => a20,
                  :projlist => [ [:iter], [:pos], [:item], [:ord,2] ]

a21 = Project.new :id => "a21", :input => a18,
                  :projlist => [ [:iter], [:pos,1], [:ord,1],
                                 [:item, "no rain on"] ]

a30 = Union.new :id => "a30", :left_rel => a26, :right_rel => a21

a32 = Rownum.new :id => "a32", :input => a30, :newcol => :pos1,
                 :order => [:ord, :pos], :part => :iter

a34 = Project.new :id => "a34", :input => a32,
                  :projlist => [ [:iter], [:pos, :pos1], [:item] ]

a31 = Rownum.new :id => "a31", :input => a27, :newcol => :pos1,
                 :order => [:ord, :pos], :part => :iter

a33 = Project.new :id => "a33", :input => a31,
                  :projlist => [ [:iter], [:pos,:pos1], [:item] ]

a35 = Union.new :id => "a35", :left_rel => a34, :right_rel => a33

a06 = Project.new :id => "a06", :input => a04,
                  :projlist => [ [:inner], [:outer,:iter], [:ord,:pos] ]

a36 = Join.new :id => "a36", :left_rel => a35, :right_rel => a06,
               :left_col => :iter, :right_col => :inner

a37 = Rownum.new :id => "a37", :input => a36, :newcol => :pos1,
                 :order => [:ord,:pos], :part => :outer

a38 = Project.new :id => "a38", :input => a37,
                  :projlist => [ [:iter,:outer], [:pos,:pos1], [:item] ]

$root = a38
