#
# VLDB submission 'Dependable Cardinality Forecasts for XQuery'
# (Jens Teubner, Torsten Grust, Sebastian Maneth, and Sherif Sakr)
#
# (c) 2008 Jens Teubner, IBM Research, teubner@us.ibm.com
#
require 'algebra'

require 'FnNumber'

class FunOneToOne < AlgebraOperator

    @@implementations = {
        "fn:number" => FnNumber }

    def new(params)

        raise "No input relation given" unless params[:input]
        raise "No output column given" unless params[:res]
        raise "No function name given" unless params[:fun_name]

        #@input = params[:input]
        #@res   = params[:res]

        impl = @@implementations[params[:fun_name]]

        raise "No implementation for #{ params[:fun_name] }" if impl.nil?

        return impl.new(params)

    end

#    #  FIXME
#    def initialize(params)
#
#        raise "No input relation given" unless params[:input]
#        raise "No output column given" unless params[:res]
#        raise "No function name given" unless params[:fun_name]
#
#        #@input = params[:input]
#        #@res   = params[:res]
#
#        impl = @@implementations[params[:fun_name]]
#
#        raise "No implementation for #{ params[:fun_name] }" if impl.nil?
#
#        @implementation = impl.new params
#
#        # set schema
#        super(params)
#
#    end
#
#    def method_missing(method, *args)
#        puts "calling #{ method }"
#        @implementation.send(method, *args)
#    end

end
