#
# VLDB submission 'Dependable Cardinality Forecasts for XQuery'
# (Jens Teubner, Torsten Grust, Sebastian Maneth, and Sherif Sakr)
#
# (c) 2008 Jens Teubner, IBM Research, teubner@us.ibm.com
#
require 'BinaryOp'

class LessThanOp < BinaryOp

    def op(x, y)

        if x.instance_of? UntypedAtomic and y.kind_of? Numeric
            x = x.to_f
        end

        if y.instance_of? UntypedAtomic and x.kind_of? Numeric
            y = y.to_f
        end

        x < y
    end

end
